#include <idc.idc>

static ModelMaterialPointers(address)
{
	auto count = Word(address + 0x16);
	if (count == 0)
	{
		return;
	}

	auto ptr = Dword(address + 0x10);
	if (ptr == 0)
	{
		return;
	}

	Message("\nNJS_MATERIAL* materials_%08X[] = {\n", ptr);

	auto i = 0;
	for (i = 0; i < count; i++)
	{
		Message("\t((NJS_MATERIAL*)0x%08X),\n", ptr + (0x14 * i));
	}

	Message("};\n");
}

static ObjectMaterialPointers(address)
{
	auto ptr;

	// Model (NJS_MODEL(_SADX))
	ptr = Dword(address + 4);
	if (ptr != 0)
	{
		ModelMaterialPointers(ptr);
	}
	
	// Child
	ptr = Dword(address + 0x2C);
	if (ptr != 0)
	{
		ObjectMaterialPointers(ptr);
	}
	
	// Sibling
	ptr = Dword(address + 0x30);	
	if (ptr != 0)
	{
		ObjectMaterialPointers(ptr);
	}
}
